//+------------------------------------------------------------------+
//|                                                        advCC.mq4 |
//|                                                  Alexey Kravtsov |
//|                                                     al_k@list.ru |
//+------------------------------------------------------------------+
#property copyright "Alexey Kravtsov"
#property link      "al_k@list.ru"

extern string SYMBOL = "EURUSD";
extern int PERIOD = 240;//H4

extern int COUNT_LOTS = 1;
extern int SLIPPAGE = 3; 
extern double SL = 0.0060;//60 .
extern double TP = 0.0120;//120 .

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
    if(iCustom(SYMBOL, PERIOD, "ConvertChannel", 0, 0) >= iHigh(SYMBOL, PERIOD, 0))//   
    {
     //sell
     OpenOrder(OP_SELL);
    }
    else
    {
      if(iCustom(SYMBOL, PERIOD, "ConvertChannel", 1, 0) <= iLow(SYMBOL, PERIOD, 0))//   
      {
       //buy
       OpenOrder(OP_BUY);
      }
      else
      {
       //    -
       if(iCustom(SYMBOL, PERIOD, "ConvertChannel", 2, 0) == iLow(SYMBOL, PERIOD, 0))
       {
        // buy
        CloseOrders(OP_BUY);
        
       }
       else
       {
         //    -
         if(iCustom(SYMBOL, PERIOD, "ConvertChannel", 2, 0) == iHigh(SYMBOL, PERIOD, 0))
         {
          // sell
          CloseOrders(OP_SELL);
         }
       }
      }
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+


bool CloseOrders(int order_type)
{
  int total=OrdersTotal();
  
  bool done = false;
  
  for(int pos=0;pos<total;pos++)
  {
     if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)==true && OrderType() == order_type)
     {
       for(int attempt = 0;done == false || attempt < 5;attempt++)
       {
         if(!OrderClose(OrderTicket(), OrderLots(), OpenPrice(order_type), SLIPPAGE))
         {
           HandleError();
         }
         else
          done = true;
       }   
     }
   }
 }
 
 double OpenPrice(int order_type)
 {
  if(order_type == OP_BUY)
   return (Ask);
  else
   return (Bid);
 }
 
 bool OpenOrder(int order_type)
 {
   bool done = false;
   
   for(int attempt = 0;done == false || attempt < 5;attempt++)
   {
      if(
         !OrderSend(SYMBOL, order_type, COUNT_LOTS, OpenPrice(order_type), SLIPPAGE, StopLoss(order_type), 
          TakeProfit(order_type))
         )
      {
       HandleError();
      }
      else
       done = true;
   }
   
 }
 double StopLoss(int order_type)
 {
   double sl = OpenPrice(order_type) - NormalizeDouble(SL, Digits);
   return (sl);
 }
 
 double TakeProfit(int order_type)
 {
  double tp = OpenPrice(order_type) + NormalizeDouble(TP, Digits);
  return (tp);
 }
 
 void HandleError()
 {
  int Error=GetLastError();                 
  switch(Error)                            
  {
   case 135:
     Print(" .   ..");
     RefreshRates();                     
     break;                           
   case 136:
     Print(" .   ..");
     while(RefreshRates()==false)        
     Sleep(1);                       
     break;                          
   case 146:
     Print("  .  ..");
     Sleep(500);                         
     RefreshRates();                     
     break;                           
  }
 }

